﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.DirectoryServices;
using System.DirectoryServices.AccountManagement;
using System.DirectoryServices.Protocols;
using System.Net;
using System.Runtime.InteropServices;

namespace info.michltechsblog.ADPasswordChange
{
    public partial class MainForm : Form
    {
        // https://msdn.microsoft.com/en-gb/library/windows/desktop/aa370650%28v=vs.85%29.aspx
        //LMErr.h
        private const uint NERR_Success = 0;
        private const uint NERR_BASE = 2100;
        private const uint NERR_UserNotFound = NERR_BASE + 121;
        private const uint NERR_NotPrimary = NERR_BASE + 126;
        private const uint NERR_PasswordTooShort = NERR_BASE + 145;
        private const uint NERR_InvalidComputer = NERR_BASE + 251;
        private const uint ERROR_ACCESS_DENIED = 5;
        private const uint ERROR_INVALID_PASSWORD = 86;
        [DllImport("netapi32.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.StdCall, SetLastError = true)]
        static extern uint NetUserChangePassword(
                [MarshalAs(UnmanagedType.LPWStr)] string domainname,
                [MarshalAs(UnmanagedType.LPWStr)] string username,
                [MarshalAs(UnmanagedType.LPWStr)] string oldpassword,
                [MarshalAs(UnmanagedType.LPWStr)] string newpassword
        );

        public MainForm()
        {
            InitializeComponent();
        }

        private void buttonChangeButton_Click(object sender, EventArgs e)
        {
            try
            {
                using (var oContext = new PrincipalContext(ContextType.Domain, textBoxDomain.Text, textBoxAccount.Text, textBoxOldPassword.Text)) 
                {
                    var user = UserPrincipal.FindByIdentity(oContext, IdentityType.SamAccountName, textBoxAccount.Text);
                    user.ChangePassword(textBoxOldPassword.Text, textBoxNewPassword.Text);
                    MessageBox.Show("Password changed successfully!","Info", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            catch (Exception Ex )
            {
                MessageBox.Show("Error while changing Password. Error: "+Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void buttonPaaswordAPI_Click(object sender, EventArgs e)
        {
            uint iReturn = NetUserChangePassword(textBoxDomain.Text, textBoxAccount.Text, textBoxOldPassword.Text, textBoxNewPassword.Text);
            string sMessage="";
                switch(iReturn)
                {
                    case NERR_Success:
                        sMessage="Password changed successfully.";
                        break;
                    case ERROR_ACCESS_DENIED:
                        sMessage = "Access denied.";
                        break;
                    case ERROR_INVALID_PASSWORD:
                        sMessage = "Invalid Password specified.";
                        break;
                    case NERR_UserNotFound:
                        sMessage = "User not found.";
                        break;
                    case NERR_NotPrimary:
                        sMessage = "Password change was not tried at the primary domain controller.";
                        break;
                    case NERR_PasswordTooShort:
                        sMessage = "Invalid Password. Too short or not meet the complexity requirements.";
                        break;
                    case NERR_InvalidComputer:
                        sMessage = "Invalid Computer.";
                        break;
                    default:
                        sMessage = "Unknown return code:" + iReturn.ToString();
                        break;
                }
            if(iReturn==NERR_Success)
            {
                MessageBox.Show(sMessage, "Info", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else
            {
                MessageBox.Show(sMessage, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}
